
#20
clrtestmemsize = 0x100 
initialstack = 0x2000
outputptr = 0x8000
perbyte = 0x42

.text

# a0 = output ptr
movel #outputptr,%a0

moveb #10,repflag

repeat:


moveb #0x1,(%a0)
# tests for Link
movew #initialstack,%a7
movew #0x1234,%d2
movel %d2,%a2
movel #0x12345678,initialstack-4


moveb #0x2,(%a0)

# sp = initialstack.  frame ptr = 0x1234
linkw %a2,#-40

moveb #0x3,(%a0)

# Check SP = ( initialstack - 4 ) - 40
movel %a7,%d3
cmpl #initialstack-44,%d3
bne fail

moveb #0x4,(%a0)

# Check (initialstack-4) = 0x1234
cmpl (initialstack-4),%d2
bne fail

moveb #0x5,(%a0)

# Check frame ptr = initialstack-4
movel %a2,%d3
cmpl #initialstack-4,%d3
bne  fail

# The Link instruction worked correctly!

moveb #0x6,(%a0)

# Now, unlink

unlk %a2

moveb #0x7,(%a0)

# Has SP been restored?
movel #initialstack,%d3 
cmpl %a7,%d3
bne  fail

moveb #0x8,(%a0)

# Has the frame ptr been restored?
cmpl %a2,%d2
bne  fail



# Now, JSR and RTS
moveb #0x9,(%a0)
jsr testprocedure

returnpoint:

# And JMP
jmp ooh

# Should never get here:
moveb #0x13,(%a0) 
bra  fail

ooh:

moveb #0x14,(%a0)

# Now test DBCC and postinc

move #clrtestmem,%a5
move #clrtestmemsize-1,%d3

moveb #0x15,(%a0)

filler:
moveb #perbyte,(%a5)+
dbra %d3,filler

moveb #0x16,(%a0)

# Is %d3 = -1?
cmpw #-1,%d3
bne fail

moveb #0x17,(%a0)

# Is %a5 correct?

movel %a5,%d4
cmpl #clrtestmem+clrtestmemsize,%d4
bne fail

moveb #0x18,(%a0)

# Is every value in the range correct?
jsr checkrange

# sum is in d7

moveb #0x19,(%a0)

cmpl #( perbyte * clrtestmemsize ),%d7
bne fail

moveb #0x20,(%a0)

# What about after a CLRB?

clrb clrtestmem+3

moveb #0x21,(%a0)

jsr checkrange

moveb #0x22,(%a0)
cmpl #(( perbyte * clrtestmemsize ) - perbyte ),%d7
bnes fail

# A CLRL?
clrl clrtestmem+16

moveb #0x23,(%a0)

jsr checkrange

moveb #0x24,(%a0)
cmpl #(( perbyte * clrtestmemsize ) - ( perbyte * 5 )),%d7
bnes fail

moveb #0x25,(%a0)

# Test LEA
# .word 0x4de8 
# .word 28
# 0100 1101 1110 1000

lea %a0@(28),%a6

moveb #0x26,(%a0)

movel #( outputptr + 28 ),%d2
cmpl %a6,%d2
bnes fail

moveb #0x27,(%a0)

# Test PEA
pea %a0@(28)

moveb #0x28,(%a0)

# Check SP
movel #( initialstack - 4 ),%d3
cmpl %a7,%d3
bnes fail

moveb #0x29,(%a0)

# Check (SP)
cmpl (%a7),%d2
bnes fail


moveb #0x30,(%a0)

# Subtract 2 from SP.

moveq #2,%d2
suba %d2,%a7

# Test SCC
seq (%a7)
moveq #0,%d2
cmpb (%a7),%d2
bnes fail

moveb #0x31,(%a0)

sne (%a7)
moveq #-1,%d2
cmpb (%a7),%d2
bnes fail


moveb #0x32,(%a0)


# Has this been run before?
# Repeat the test until repflag = 0
subqb #1,repflag
bge repeat


moveb #0xa5,(%a0)

# This is actually a pass.
# But we go into the fail loop anyway with a success code (a5)

fail:

movel %a7,spout
movel %a6,fpout
movel %d3,d3out
movel %d4,d4out
failloop:
bras failloop



testprocedure:
moveb #0x10,(%a0)

# Check the stack pointer is correct
movel %a7,%d3
cmpl #initialstack-4,%d3
bnes fail

moveb #0x11,(%a0)

# Check the return point has been stacked correctly
movel (%a7),%d3
cmpl #returnpoint,%d3
bnes fail

moveb #0x12,(%a0)
rts



checkrange:
moveql #0,%d7
moveql #0,%d5
move #clrtestmemsize+clrtestmem,%d6
move #clrtestmem,%a6
checkrange_loop:
moveb (%a6),%d5
addl %d5,%d7
addq #1,%a6
cmpl %a6,%d6
bgts checkrange_loop
rts



.bss
regdumpspace:
spout:
.space 4
fpout:
.space 4
d3out:
.space 4
d4out:
.space 4
clrtestmem:
.space clrtestmemsize
repflag:
.space 1



