
    do_branch_process : process ( instruction_register , 
                    carry , overflow , negative , zero ) is
        variable db : std_logic ;
    begin
        -- Examine the condition code. Only the top 3 bits need
        -- to be examined because the lowest bit of the code means
        -- "complement result".
        case instruction_register ( 11 downto 9 ) is
        when "001" =>   -- BHI, high
                        db := ( not carry ) and ( not zero ) ;
        when "010" =>   -- BCC, carry clear
                        db := not carry ;
        when "011" =>   -- BNE, not equal
                        db := not zero ;
        when "100" =>   -- BVC, overflow clear
                        db := not overflow ;
        when "101" =>   -- BPL, plus
                        db := not negative ;
        when "110" =>   -- BGE, greater than or equal
                        db := ( negative and overflow )
                                or (( not negative ) and ( not overflow )) ;
        when "111" =>   -- BGT, greater than
                        db := ( negative and overflow and ( not zero ))
                                or (( not negative ) and ( not overflow )
                                        and ( not zero )) ;
        when others =>  -- BRA, branch always
                        db := '1' ;
        end case ;

        if ( instruction_register ( 8 ) = '1' )
        then
            -- Complement result of examination above.
            db := not db ;
        end if ;

        condition_true <= db ;
    end process do_branch_process ;

